package nc.ui.gl.multibooksdef;

import java.awt.Component;
import java.awt.Insets;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.EventObject;
import java.util.Vector;
import javax.swing.JFrame;
import javax.swing.JTable;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.EventListenerList;
import javax.swing.table.TableCellEditor;
import nc.bs.logging.Log;
import nc.ui.glcom.control.GlComboBox;

public class CobTableCellEditor extends GlComboBox implements TableCellEditor {

   protected EventListenerList listenerList = new EventListenerList();
   protected transient ChangeEvent changeEvent = null;
   protected transient JTable m_table = null;
   CobTableCellEditor.IvjEventHandler ivjEventHandler = new CobTableCellEditor.IvjEventHandler();
   public boolean m_blnEditable = false;


   public CobTableCellEditor() {
      this.initialize();
   }

   public CobTableCellEditor(Object[] p0) {
      super(p0);
   }

   public CobTableCellEditor(Object[] p0, Object[] p1) {
      super(p0, p1);
   }

   public CobTableCellEditor(Vector p0) {
      super(p0);
   }

   public CobTableCellEditor(Vector p0, Vector p1) {
      super(p0, p1);
   }

   public void addCellEditorListener(CellEditorListener l) {
      this.listenerList.add(CellEditorListener.class, l);
   }

   public void cancelCellEditing() {
      this.fireEditingCanceled();
   }

   public void cobTableCellEditor_ItemStateChanged(ItemEvent itemEvent) {
      if(itemEvent.getStateChange() == 1) {
         this.stopCellEditing();
      }

   }

   private void connEtoC1(ItemEvent arg1) {
      try {
         this.cobTableCellEditor_ItemStateChanged(arg1);
      } catch (Throwable var3) {
         this.handleException(var3);
      }

   }

   protected void fireEditingCanceled() {
      Object[] listeners = this.listenerList.getListenerList();

      for(int i = listeners.length - 2; i >= 0; i -= 2) {
         if(listeners[i] == CellEditorListener.class) {
            if(this.changeEvent == null) {
               this.changeEvent = new ChangeEvent(this);
            }

            ((CellEditorListener)listeners[i + 1]).editingCanceled(this.changeEvent);
         }
      }

   }

   protected void fireEditingStopped() {
      Object[] listeners = this.listenerList.getListenerList();

      for(int i = listeners.length - 2; i >= 0; i -= 2) {
         if(listeners[i] == CellEditorListener.class) {
            if(this.changeEvent == null) {
               this.changeEvent = new ChangeEvent(this);
            }

            ((CellEditorListener)listeners[i + 1]).editingStopped(this.changeEvent);
         }
      }

   }

   public Object getCellEditorValue() {
      return super.getSelectedUserData();
   }

   public int getClickCountToStart() {
      return 10;
   }

   public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
      return this;
   }

   private void handleException(Throwable exception) {
      Log.getInstance(this.getClass()).info("--------- 未捕捉到的异常 ---------");
      exception.printStackTrace(System.out);
   }

   private void initConnections() throws Exception {
      this.addItemListener(this.ivjEventHandler);
   }

   private void initialize() {
      try {
         this.setName("CobTableCellEditor");
         this.setSize(100, 22);
         this.initConnections();
      } catch (Throwable var2) {
         this.handleException(var2);
      }

   }

   public boolean isCellEditable(EventObject anEvent) {
      return this.m_blnEditable;
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         CobTableCellEditor aCobTableCellEditor = new CobTableCellEditor();
         exception.setContentPane(aCobTableCellEditor);
         exception.setSize(aCobTableCellEditor.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.gl.multibooksdef.CobTableCellEditor 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void removeCellEditorListener(CellEditorListener l) {
      this.listenerList.remove(CellEditorListener.class, l);
   }

   public boolean shouldSelectCell(EventObject anEvent) {
      return true;
   }

   public boolean stopCellEditing() {
      this.fireEditingStopped();
      return true;
   }

   class IvjEventHandler implements ItemListener {

      public void itemStateChanged(ItemEvent e) {
         if(e.getSource() == CobTableCellEditor.this) {
            CobTableCellEditor.this.connEtoC1(e);
         }

      }
   }
}
